unit Unit2;
interface
uses
  Windows, Messages, SysUtils, Classes, ComServ, ComObj, VCLCom, DataBkr,
  DBClient, Project1_TLB, StdVcl, Db, DBTables, Provider;

type
  TTDM57 = class(TRemoteDataModule, ITDM57)
    Table1: TTable;
    DataSetProvider1: TDataSetProvider;
    procedure DataSetProvider1BeforeGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
    procedure DataSetProvider1AfterGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
  private
    { Private declarations }
  protected
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;
  public
    { Public declarations }
  end;

implementation
{$R *.DFM}

class procedure TTDM57.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

procedure TTDM57.DataSetProvider1BeforeGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
begin
  if OwnerData <> '' then
    with Sender AS TProvider do
      DataSet.Locate('Key',OwnerData, []);
end;

procedure TTDM57.DataSetProvider1AfterGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
begin
  with Sender AS TProvider do
    OwnerData := DataSet.RecordCount
end;

initialization
  TComponentFactory.Create(ComServer, TTDM57,
    Class_TDM57, ciMultiInstance, tmApartment);
end.
